// ****************************************************************************
// *** LOGGING SYSTEM *********************************************************
// ****************************************************************************
var appName = "node";
const setAppName = function(name) {
    appName = name.toString().trim();
};
const getAppName = function() {
    return appName;
};
const appPid = process.pid;
const appPpid = process.ppid;
const logLevels = [ "TRACE", "DEBUG", "INFOR", "WARNG", "ERROR", "FATAL" ];
var logLevel = 2;
const setLevel = function(level) {
    if (typeof level === "number") {
        if (level>=0 && level<logLevels.length)
            logLevel = level;
    } else {
        level = level.toString().trim().toUpperCase();
        level = logLevels.indexOf(level);
        if (level>=0) logLevel = level;
    }
};
const getLevel = function() {
    return logLevels[logLevel];
};
const logMessageDate = function() {
    return (new Date()).toISOString().substring(0,23).replace("T"," ");
};
const logMessageApp = function() {
    return appName + ":" + appPid + ":" + appPpid;
}
const logMessage = function(message,name,level) {
    if (level >= logLevel)
      console.log("[" + logMessageDate() + "] <" + logMessageApp() + "> {" + name + "} (" + getLevel() + ") " + message);
};
const newLog = function(name) {
    return {
        t : function(message){return logMessage(message,name,0);},
        d : function(message){return logMessage(message,name,1);},
        i : function(message){return logMessage(message,name,2);},
        w : function(message){return logMessage(message,name,3);},
        e : function(message){return logMessage(message,name,4);},
        f : function(message){return logMessage(message,name,5);}
    };
};
// ****************************************************************************
const LOG = {
    setAppName : setAppName,
    getAppName : getAppName,
    setLevel   : setLevel,
    getLevel   : getLevel,
    newLog     : newLog
};
// ****************************************************************************
module.exports = LOG;